/*
 * bitmap.c
 * `֘A
 *
 *  Created on: 2010/03/03
 *      Author: Choi Kyun
 */

//#define GLOBAL_VALUE_DEFINE

#include "bitmap.h"
#include "type.h"

/************************************************
 * zVRAMNA
 ***********************************************/
void
clear_screen( void )
{
  int i, j;
  UInt32 *screen = (UInt32 *) _vram + (SCREEN_WIDTH + SCREEN_WIDTH_BLANK) /4;

  for( j = 0; j < (SCREEN_HEIGHT - SCREEN_HEIGHT_BLANK * 2) / 8; j++ )
    {
      for( i = 0; i < ( SCREEN_WIDTH - SCREEN_WIDTH_BLANK * 2 ) / 4 / 6; i++ )
        {
          *(uint24_t *)screen++ = (uint24_t) 0;//32bit * 6
          *(uint24_t *)screen++ = (uint24_t) 0;
          *(uint24_t *)screen++ = (uint24_t) 0;
          *(uint24_t *)screen++ = (uint24_t) 0;
          *(uint24_t *)screen++ = (uint24_t) 0;
          *(uint24_t *)screen++ = (uint24_t) 0;
         }
      screen += (SCREEN_WIDTH_BLANK * 2) /4;
    }
}
//void
//clear_screen( void )
//{
//  int i, j;
//  UInt8 *screen = (UInt8 *) _vram + (SCREEN_WIDTH + SCREEN_WIDTH_BLANK);
//
//  for( j = 0; j < (SCREEN_HEIGHT - SCREEN_HEIGHT_BLANK * 2) / 8; j++ )
//    {
//      for( i = 0; i < ( SCREEN_WIDTH - SCREEN_WIDTH_BLANK * 2 ); i++ )
//        {
//          *screen++ = 0;//32bit * 6
//        }
//      screen += (SCREEN_WIDTH_BLANK * 2);
//    }
//}
/************************************************
 * zVRAMVRAM
 ***********************************************/
void
disp_screen( void )
{
  int i, j;
  UInt16 *screen = (UInt16 *) _vram + (SCREEN_WIDTH + SCREEN_WIDTH_BLANK) / 2;
  UInt16 *lcd = (UInt16 *) VRAM_BASE;

  for( j = 0; j < LCD_HEIGHT / 8; j++ )
    {
      for( i = 0; i < LCD_WIDTH / 2 / 9; i++ )
        {
          *lcd++ = *screen++;
          *lcd++ = *screen++;
          *lcd++ = *screen++;
          *lcd++ = *screen++;
          *lcd++ = *screen++;
          *lcd++ = *screen++;
          *lcd++ = *screen++;
          *lcd++ = *screen++;
          *lcd++ = *screen++;
        }
      lcd += (LINE_BYTES - LCD_WIDTH)/2;
      screen += (SCREEN_WIDTH_BLANK * 2)/2;
    }
}

/************************************************
 * 8~n LN^\ihbgPʁj
 * x : xW
 * y : yW
 * width F xTCY
 * data F rbg}bvf[^
 ***********************************************/
void
draw_bitmap( int x, int y, int width, UInt8 *data )
{
  int i;
  UInt8 *screen = (UInt8 *) _vram;
  UInt16 shift = 0;

  if( x >= SCREEN_WIDTH - width || y >= SCREEN_HEIGHT - 8 )
    return;

  screen += ( y / 8 ) * SCREEN_WIDTH + x;

  for( i = 0; i < width; i++ )
    {
      shift = *data++;
      shift <<= y & 7;
      *screen |= shift;
      *( screen + SCREEN_WIDTH ) |= shift >> 8;
      screen++;
    }
}

/************************************************
 * 8~n LN^\i8hbgPʁj
 * x : xW ACg
 * y : yW 0-5
 * width F xTCY 2byteP
 * data F rbg}bvf[^ 16bit
 ***********************************************/
void
set_bitmap( int x, int y, int width, UInt16 *data )
{
  int i;
  UInt16 *screen = (UInt16 *) _vram;

  if( x >= SCREEN_WIDTH - width || y >= SCREEN_HEIGHT/8 - 1 )
    return;

  screen += (y * SCREEN_WIDTH + x) / 2;

  for( i = 0; i < width / 2; i++ )
    {
        *screen++ = *data++;
     }
}

