/*
 * key.h
 *
 *  Created on: 2010/03/04
 *      Author: ECOCON
 */

#ifndef KEY_H_
#define KEY_H_

#include "type.h"

#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif


#define KEY_RIGHT (1<<6)
#define KEY_LEFT (1<<7)

#define DIR_IN (0)
#define DIR_OUT (1)

#define PORT0 (0)
#define PORT1 (1)
#define PORT2 (2)
#define PORT3 (3)

#define PIN_0 (1<<0)
#define PIN_1 (1<<1)
#define PIN_2 (1<<2)
#define PIN_3 (1<<3)
#define PIN_4 (1<<4)
#define PIN_5 (1<<5)
#define PIN_6 (1<<6)
#define PIN_7 (1<<7)

#define EDGE_UP (0)
#define EDGE_DOWN (1)

#define FILTER_NONE (0)
#define FILTER_128us (1)
#define FILTER_256us (2)
#define FILTER_512us (3)
#define FILTER_1ms (4)
#define FILTER_2ms (5)
#define FILTER_4ms (6)
#define FILTER_8ms (7)

void
setAntiChattering( int port, int filter );

void
setPinDirection( int port, int pin, int inout );

void
get_key( void );

void
init_key( void );


//L[Xe[^X
GLOBAL UInt8 _key;
GLOBAL UInt8 _keyf;


#endif /* KEY_H_ */
